﻿if (!nts.ui.advancedSearch) {
    nts.ui.advancedSearch = {
        /*Функция за вземане на ресурсен файл като текст*/
        loadXMLDoc: function (dname) {
            if (window.XMLHttpRequest) {
                xhttp = new XMLHttpRequest();
            }
            else {
                xhttp = new ActiveXObject("Microsoft.XMLHTTP");
            }
            xhttp.open("GET", dname, false);
            try { xhttp.responseType = "msxml-document" } catch (err) { } // Helping IE
            xhttp.send();
            return xhttp;
        },
        /*Нужно е за Infragistics List View за създаване на шаблон и bind с променливата*/
        dataSet: [{ "ID": null, "ParentId": null, "Number": null, "Year": null, "Country": null, "NoticeType": null, "NoticeName": null, "Waterway": null, "AreaFrom": null, "AareaTo": null, "RiverKmFrom": null, "RiverKmTo": null, "ValidFrom": null, "ValidTo": null, "IssueFrom": null, "IssueTo": null, "TextFormat": null, "XMLFormat": null, "CodeFormat": null, "HasAttachment": null, "AttachmentFormat": null, "Ftm": null, "Wrm": null, "Icem": null, "Werm": null }],

        searchTypes: { advancedSearch: "advancedSearch", detailedSearch: "detailedSearch" },
        searchType: "",
        doc: {},
        xml: {},

        /*Взима от ресурсния файл формата на датата и всички етикети нужни за контролата на конкретния език*/
        getDateParams: function () {
            var dateFormat = nts.locale.getLocalizedResource("DateFormat");
            var headerFormat = nts.locale.getLocalizedResource("HeaderFormat");
            var dateFieldOrder = nts.locale.getLocalizedResource("DateFieldOrder");
            var dateBtnLbl = nts.locale.getLocalizedResource("DateButtonLabel");
            var clearButton = nts.locale.getLocalizedResource("ClearButton");
            nts.ui.advancedSearch.ChangeDateFormat(dateFormat, headerFormat, dateFieldOrder, dateBtnLbl, clearButton);
        },
        /*използва се при промяна на езика за промяна на формата на полета за дати*/
        ChangeDateFormat: function (dateFormat, headerFormat, dateFieldOrderStr, dateBtnLbl, clearBtn) {

            $("#ToValidity").val('');
            $("#FromValidity").val('');
            $("#IssueTo").val('');
            $("#IssueFrom").val('');
            var dateFieldOrderTemp = {};

            var j = 0;
            for (var i = 0; i < dateFieldOrderStr.length; i++) {
                if (dateFieldOrderStr[i] != ',') {
                    dateFieldOrderTemp[j] = dateFieldOrderStr[i];
                    j++;
                }
            }

            var dateFieldOrder = [dateFieldOrderTemp[0], dateFieldOrderTemp[1], dateFieldOrderTemp[2]];

            $("#ToValidity").datebox({
                overrideDateFormat: dateFormat,
                overrideHeaderFormat: headerFormat,
                overrideDateFieldOrder: dateFieldOrder,
                overrideSetDateButtonLabel: dateBtnLbl
            });

            $("#FromValidity").datebox({
                overrideDateFormat: dateFormat,
                overrideHeaderFormat: headerFormat,
                overrideDateFieldOrder: dateFieldOrder,
                overrideSetDateButtonLabel: dateBtnLbl
            });


            $("#IssueTo").datebox({
                overrideDateFormat: dateFormat,
                overrideHeaderFormat: headerFormat,
                overrideDateFieldOrder: dateFieldOrder,
                overrideSetDateButtonLabel: dateBtnLbl,
                overrideClearButton: clearBtn
            });

            $("#IssueFrom").datebox({
                overrideDateFormat: dateFormat,
                overrideHeaderFormat: headerFormat,
                overrideDateFieldOrder: dateFieldOrder,
                overrideSetDateButtonLabel: dateBtnLbl,
                overrideClearButton: clearBtn
            });


            var month = new Date().getMonth();
            month = month + 1;

            var toDate = new Date(new Date().getFullYear(), month, new Date().getDate());

            //jQuery.extend(jQuery.mobile.datebox.prototype.options, {
            //    'overrideDateFormat': dateFormat,
            //    'overrideHeaderFormat': headerFormat,
            //    'overrideDateFieldOrder': dateFieldOrder,
            //    'overrideSetDateButtonLabel': dateBtnLbl,
            //    'overrideClearButton': clearBtn
            //});

            $("#ToValidity").val(nts.ui.advancedSearch.changeDateToFormatedDate(new Date(), dateFormat));
            $("#FromValidity").val(nts.ui.advancedSearch.changeDateToFormatedDate(toDate, dateFormat));


            $('#FromValidity').trigger('datebox', {
                'method': 'set',
                'value': nts.ui.advancedSearch.changeDateToFormatedDate(new Date(), dateFormat)
            }).trigger('datebox', {
                'method': 'doset'
            });

            $('#ToValidity').trigger('datebox', {
                'method': 'set',
                'value': nts.ui.advancedSearch.changeDateToFormatedDate(toDate, dateFormat)
            }).trigger('datebox', {
                'method': 'doset'
            });

        },
        /*форматира подадена като параметър дата с подаден формат и добавя водеща нула водеща нула*/
        changeDateToFormatedDate: function (date, format) {
            if (date.getDate() < 10) {
                if ((date.getMonth() + 1) < 10)
                    var formatedDate = format.replace('%d', '0' + date.getDate()).replace('%m', '0' + (date.getMonth() + 1)).replace('%Y', date.getFullYear());
                else
                    var formatedDate = format.replace('%d', '0' + date.getDate()).replace('%m', (date.getMonth() + 1)).replace('%Y', date.getFullYear());
            } else {
                if ((date.getMonth() + 1) < 10)
                    var formatedDate = format.replace('%d', date.getDate()).replace('%m', '0' + (date.getMonth() + 1)).replace('%Y', date.getFullYear());
                else
                    var formatedDate = format.replace('%d', date.getDate()).replace('%m', (date.getMonth() + 1)).replace('%Y', date.getFullYear());
            }
            return formatedDate;
        },

        /*попълва падащите менюта за първа и последна локация на съобщението*/
        getLocations: function () {

            $("#WaterWayTo option").each(function () {
                $(this).remove();
            });

            $("#WaterWayFrom option").each(function () {
                $(this).remove();
            });

            var lang;
            if (nts.config.language.value == "BG") lang = "BG";
            else lang = "EN";


            nts.ui.advancedSearch.xml.find('Country').each(function () {
                if ($(this).find('CountryCode').text() == $("#Country").val()) {
                    $(this).find('Waterway').each(function () {
                        var self = this;
                        $(this).find('WaterwayName').each(function () {
                            if ($(this).find('Name').text() == $("#WaterWay").find("option[value='" + $("#WaterWay").val() + "']").text()) {
                                $(self).find('Location').each(function () {
                                    var currLoc = this;
                                    $(this).find('LocationName').each(function () {
                                        if ($(this).find('Lang').text() == lang) {
                                            $("#WaterWayFrom").append("<option value='" + ($(currLoc).find('Hm').text() / 10) + "'>" + $(this).find('Name').text() + "</option>");
                                            $("#WaterWayTo").append("<option value='" + ($(currLoc).find('Hm').text() / 10) + "'>" + $(this).find('Name').text() + "</option>");
                                            return false;
                                        }
                                    });
                                });
                                return false;
                            }
                        });
                    });
                    return false;
                }
            });


            $("#WaterWayFrom").val($("#WaterWayFrom option:first-child").val());
            $("#WaterWayFrom").prev().children("span:first-child").children().text($("#WaterWayFrom option:first-child").text());

            $("#WaterWayTo").val($("#WaterWayTo option:last-child").val());
            $("#WaterWayTo").prev().children("span:first-child").children().text($("#WaterWayTo option:last-child").text());


            $("#KmFrom").val($("#WaterWayFrom").val());
            $("#KmTo").val($("#WaterWayTo").val());
        },
        /*попълва падащото меню с всички държави спрямо избрания език*/
        getCountryList: function () {

            $("#Country option").each(function () {
                $(this).remove();
            });

            var CountryCode = [];
            var CountryName = [];
            var counter = 0;
            nts.ui.advancedSearch.xml.find('Country').each(function () {
                CountryCode[counter] = $(this).find('CountryCode').text();
                counter++;
            });

            counter = 0;

            nts.ui.advancedSearch.xml.find('Country').each(function () {
                $(this).find('CountryName').each(function () {
                    if ($(this).find('Lang').text() == nts.config.language.value) {
                        CountryName[counter] = $(this).find('Name').text();
                        return false;
                    }
                });
                counter++;
            });

            if (CountryName.length == 0) {
                nts.ui.advancedSearch.xml.find('Country').each(function () {
                    $(this).find('CountryName').each(function () {
                        if ($(this).find('Lang').text() == "EN") {
                            CountryName[counter] = $(this).find('Name').text();
                            return false;
                        }
                    });
                    counter++;
                });
            }

            for (var i = 0; i < counter; i++) {
                $('#Country').append("<option value='" + CountryCode[i] + "'>" + CountryName[i] + "</option>");
            }


            $("#Country").val($("#Country option:first-child").val());
            $("#Country").prev().children("span:first-child").children().text($("#Country option:first-child").text());

        },
        /*Изполва се за попълване на падащото меню съдържащо всички реки за дадената държава*/
        getWaterWayList: function () {

            $("#WaterWay option").each(function () {
                $(this).remove();
            });

            nts.ui.advancedSearch.xml.find('Country').each(function () {
                if ($(this).find('CountryCode').text() == $("#Country").val()) {
                    $(this).find('Waterway').find('WaterwayName').each(function () {
                        var optionVal = $(this).parent().find("WaterWaySection").text();

                        if (nts.config.language.value == "BG") {
                            if ($(this).find('Lang').text() == "BG") {
                                $("#WaterWay").append("<option value='" + optionVal + "'>" + $(this).find('Name').text() + "</option>");
                                return true;
                            }
                        } else {
                            if ($(this).find('Lang').text() == "EN") {
                                $("#WaterWay").append("<option value='" + optionVal + "'>" + $(this).find('Name').text() + "</option>");
                                return true;
                            }
                        }
                    });
                    return false;
                }
            });

            $("#WaterWay").val($("#WaterWay option:first-child").val());
            $("#WaterWay").prev().children("span:first-child").children().text($("#WaterWay option:first-child").text());
        },
        /*Използа се при успешно получаване на координатите от устройството*/
        onGeoLocationSuccess: function (position) {
            debugger;
            $("#latitude").val(position.coords.latitude);
            $("#longitude").val(position.coords.longitude);

            var dataObject = { latitude: position.coords.latitude, longitude: position.coords.longitude, KmRadius: $("#KmRadius").val() };
            var ajaxOptions = {
                //crossDomain: true,
                //async: false,
                //cache:false,
                //headers: {
                //    "Access-Control-Allow-Origin": "*"
                //},
                url: nts.config.serverUrl + "/Mobile/GetLocationParams?latitude=" + dataObject.latitude + "&longitude=" + dataObject.longitude + "&KmRadius=" + dataObject.KmRadius,
                //  data: dataObject,
                type: "GET"
            };

            nts.communicator.ajaxCall(ajaxOptions)
            .then(nts.ui.advancedSearch.currentPostionResult, nts.communicator.onFailedAjax);
           // .then($.mobile.hidePageLoadingMsg);
                
        },

        // onError Callback receives a PositionError object
        onGeoLocationError: function (error) {

            $("#messageDialogTitle").text(error.code);
            $("#messageDialogMessageContainer").text(error.message);
            $.mobile.changePage("messageDialog.html");
        },
        /*Използва се при отговор от заявката за търсене по гео-локация*/
        currentPostionResult: function (data) {
            $.mobile.hidePageLoadingMsg();
            if (data.CountryCode != "" && data.CountryCode != null) {

                $("#Country option").each(function () {
                    if ($(this).val() == data.CountryCode) {
                        $("#Country").val($(this).val());
                        $("#Country").prev().children("span:first-child").children().text($(this).text());
                        return false;
                    }
                });

                $("#CountryReadOnly").text($("#Country option[value='" + $("#Country").val() + "']").text());

                $("#WaterWayReadOnly").text(data.WaterWay);


                $("#WaterWayFrom option").each(function () {
                    if ($(this).val() <= data.KMFrom) {
                        $("#WaterWayFrom").val($(this).val());
                        $("#WaterWayFrom").prev().children("span:first-child").children().text($(this).text());
                        $("#KmFrom").val($(this).val());
                    }
                });
                $("#WaterWayFromReadOnly").text($("#WaterWayFrom option[value='" + $("#WaterWayFrom").val() + "']").text());

                $("#WaterWayTo option").each(function () {

                    if ($(this).val() >= data.KMTo) {
                        $("#WaterWayTo").val($(this).val());
                        $("#WaterWayTo").prev().children("span:first-child").children().text($(this).text());
                        $("#KmTo").val($(this).val());
                        return false;
                    }
                });
                $("#WaterWayToReadOnly").text($("#WaterWayTo option[value='" + $("#WaterWayTo").val() + "']").text());
            } else {
                $("#CountryReadOnly").text(nts.locale.getLocalizedResource('NO_SEARCH_RESULT'));
                $("#WaterWayReadOnly").text(nts.locale.getLocalizedResource('NO_SEARCH_RESULT'));
                $("#WaterWayToReadOnly").text(nts.locale.getLocalizedResource('NO_SEARCH_RESULT'));
                $("#WaterWayFromReadOnly").text(nts.locale.getLocalizedResource('NO_SEARCH_RESULT'));
                $("#KmFrom").val('');
                $("#KmTo").val('');
            }
         //  $.mobile.changePage("advancedSearch.html");
        },
        /*Използва се за резултат от подробното търсене*/
        res: function (data) {
            $.mobile.hidePageLoadingMsg();
            if (data.isRejected != undefined && data.isRejected()) {
                $("#messageDialogTitle").text(nts.locale.getLocalizedResource("lblError"));
                $("#messageDialogMessageContainer").text(nts.locale.getLocalizedResource("NO_CONNECTION_TO_SERVER"));
                $.mobile.changePage("messageDialog.html");
            } else {
                if (data != "") {
                    nts.ui.advancedSearch.dataSet = data;
                    $.mobile.changePage("nestedList.html");
                } else {
                    var message = nts.locale.getLocalizedResource("NO_SEARCH_RESULT");
                    $("#messageDialogTitle").text(message);
                    $("#messageDialogMessageContainer").text(message);
                    $.mobile.changePage("messageDialog.html");
                }
            }
            return;
        },
        postResult: function (data) {
            $.mobile.hidePageLoadingMsg();
            if (data.isRejected != undefined && data.isRejected()) {
                $("#messageDialogTitle").text(nts.locale.getLocalizedResource("lblError"));
                $("#messageDialogMessageContainer").text(nts.locale.getLocalizedResource("NO_CONNECTION_TO_SERVER"));
                $.mobile.changePage("messageDialog.html");
            } else {
                if (data != "") {
                    var array = [];
                    nts.ui.advancedSearch.dataSet = array.concat(data, nts.ui.advancedSearch.dataSet);
                    nts.ui.listSettings.setButtonDisplay(nts.ui.listSettings.selectedNoticeTypeGlobal);
                    nts.ui.listSettings.setListItemsDisplay(nts.ui.listSettings.selectedNoticeTypeGlobal);
                    nts.ui.listSettings.filterCheck();
                    nts.ui.listSettings.beforeShow();
                } else {
                    var message = nts.locale.getLocalizedResource("NO_SEARCH_RESULT");
                    $("#messageDialogTitle").text(message);
                    $("#messageDialogMessageContainer").text(message);
                    $.mobile.changePage("messageDialog.html");
                }
            }
        }
    }
}