﻿if (!nts.locale) {
    nts.locale = {
        resources: {},
        loadResources: function () {
            try{
                lang = nts.config.language.value;

                if (nts.locale.resources[lang])
                    return Promise.resolve();
                else
                    return nts.locale.loadResourceFile("../resources/Resources." + lang.toLowerCase() + ".xml");         
            }
            catch(e)
            {
                return Promise.reject(e);
            }
        },
        handleResourcesError: function (e) {
            console.log('-----Error: Грешка при локализацията.', e); //няма ресурсни файлове или nts.config
        },
        loadResourceFile: function(fileName)
        {
            return nts.fileManager.readXMLfile(fileName).then(nts.locale.getKeyDataFromXML);
        },
        getKeyDataFromXML: function (xml) {
            try {
                lang = nts.config.language.value;
                nts.locale.resources[lang] = {};
                xml.find('data').each(function () {
                    nts.locale.resources[lang][$(this).attr("name")] = $(this).find('value').text();
                });
                return Promise.resolve();
            }
            catch (e) { return Promise.reject(e); }
        },
        getLocalizedResource: function (resourceCode)
        { 
            try {
                lang = nts.config.language.value;
                localizedResource = nts.locale.resources[lang][resourceCode];
                return localizedResource;
            }
            catch (e) {
                console.log('-----Error: Грешка при локализацията.', е);
                return null;
            }
        },
        localize: function (elementId) {
            try{
                if (nts.locale.resources[nts.config.language.value]) {
                    var translatables;
                    if (elementId) {
                        translatables = $('#' + elementId).find("[glb_id]");
                    }
                    else {
                        var pages = $("div[data-role='page']");
                        translatables = $(pages).find("[glb_id]");
                    }

                    $(translatables).each(function () {
                        resourceCode = $(this).attr("glb_id");
                        localizedResource = nts.locale.getLocalizedResource(resourceCode);
                        if (localizedResource) {
                            if (this.tagName == "INPUT") {
                                $(this).attr("placeholder", localizedResource);
                                $(this).attr("title", localizedResource);
                            } else {
                                if (($(this).attr('data-role') == "button" || $(this).hasClass("ui-collapsible-heading") || $(this).hasClass("ui-btn")) && $(this).find('.ui-btn-text').length == 1) {
                                    $(this).find('.ui-btn-text').text(localizedResource);
                                }
                                //else if ($(this).attr('data-role') == "collapsible" && $(this).find('.ui-collapsible-heading .ui-btn-text').length == 1) {
                                //    $(this).find('.ui-collapsible-heading .ui-btn-text').text(localizedResource);
                                //} 
                                else
                                    $(this).text(localizedResource);
                            }
                        }
                        else {
                            console.log('-----Error: Грешка при локализацията. Липсва ресурс за код: ', resourceCode);
                        }
                    });
                }
            }
            catch (e) { }
        },
        localizeMainPage: function () {
            //return new Promise(function (resolve) {
            //    nts.locale.localize("main");
            //    resolve();
            //});
            nts.locale.localize("main");
        },
        localizeAllPages: function () {
            //return new Promise(function (resolve) {
            //    nts.locale.localize();
            //    resolve();
            //});
            nts.locale.localize();
        }
    }
}