﻿if (!nts.ui.logIn) {
    nts.ui.logIn = {
        logInAttemp: {},
        logIn: function () {
            var logInForm = $("#logIn form");
            if (logInForm.valid()) {

                $.mobile.showPageLoadingMsg();

                var logInURL = nts.config.serverUrl + "/Mobile/LogIn";
                var userEmail = $("#logInUserEmail").val();
                var password = $("#logInUserPassword").val();
                var hashedPassword = CryptoJS.MD5(password).toString();

                nts.ui.logIn.logInAttemp.activeUser = userEmail;
                if (nts.ui.logIn.logInAttemp[nts.ui.logIn.logInAttemp.activeUser] && nts.ui.logIn.logInAttemp[nts.ui.logIn.logInAttemp.activeUser] > 2) {
                    nts.communicator.onError("3_WRONG_ATTEMPTS").then($.mobile.hidePageLoadingMsg);
                }
                else {
                    var ajaxOptions = {
                        url: logInURL,
                        data: { userEmail: userEmail, password: hashedPassword }
                    };

                    nts.communicator.ajaxCall(ajaxOptions)
                        .then(nts.ui.logIn.logInSuccess, nts.ui.logIn.logInError)
                        .then($.mobile.hidePageLoadingMsg);
                }
            }
        },
        logInSuccess: function (data) {
            nts.user.loggedInUser = data;
            $.mobile.changePage("userSubscriptions.html");
        },
        logInError: function (error) {
            var errorCode = "";
            if (error && error.responseText) {
                try {
                    errorCode = JSON.parse(error.responseText);
                }
                catch (e) { }
            }
            if (errorCode === "LOG_IN_FAILED") {
                //if LOG_IN_FAILED
                if (!nts.ui.logIn.logInAttemp[nts.ui.logIn.logInAttemp.activeUser]) {
                    nts.ui.logIn.logInAttemp[nts.ui.logIn.logInAttemp.activeUser] = 0;
                }
                nts.ui.logIn.logInAttemp[nts.ui.logIn.logInAttemp.activeUser] += 1;

                if (nts.ui.logIn.logInAttemp[nts.ui.logIn.logInAttemp.activeUser] > 2)
                    return nts.communicator.onError("3_WRONG_ATTEMPTS");
                else
                    return nts.communicator.onError("LOG_IN_FAILED");
            }
            else
                return nts.communicator.onFailedAjax(error);           
        },
        initValidation: function () {
            if ($("#logIn form").length > 0) {
                try {
                    $("#logIn form").validate({
                        rules: {
                            logInUserEmail: {
                                required: true,
                                email: true
                            },
                            logInUserPassword: {
                                required: true
                            }
                        },
                        messages: {
                            logInUserEmail: {
                                required: function (element) {
                                    return jQuery.validator.format(nts.locale.getLocalizedResource("lblRequiredField"), nts.locale.getLocalizedResource("lblUserEmail"));
                                },
                                email: function (element) {
                                    return nts.locale.getLocalizedResource("lblInvalidEmail");
                                }
                            },
                            logInUserPassword: {
                                required: function (element) {
                                    return jQuery.validator.format(nts.locale.getLocalizedResource("lblRequiredField"), nts.locale.getLocalizedResource("lblUserPassword"));
                                }
                            }
                        },
                        focusInvalid: false
                    });
                }
                catch (e) {
                    nts.communicator.logError(e);
                    console.log('-----Error: Грешка при инициализацията на jquery validate. Вероятно липсват ресурсни кодове.');
                }
            }
        },
        register: function ()
        {
            if (nts.user.loggedInUser) nts.user.loggedInUser = undefined;
            $.mobile.changePage("userDetails.html");
        }
    }
}