﻿//---------------------- Инициализация
var nts = {
    ui: {},
    config: {},
    version: "1.0.6",
    configFileName: "config.txt",
    emulatorMode: window.tinyHippos != undefined,
    languages: {
        "BG": { text: "Български", value: "BG", forTextNotices: false, forUI: true }, "CS": { text: "Česky", value: "CS", forTextNotices: false, forUI: false },
        "DE": { text: "Deutsch", value: "DE", forTextNotices: true, forUI: false }, "EN": { text: "English", value: "EN", forTextNotices: true, forUI: true },
        "FR": { text: "Français", value: "FR", forTextNotices: true, forUI: false }, "HR": { text: "Hrvatski", value: "HR", forTextNotices: false, forUI: false },
        "HU": { text: "Magyar", value: "HU", forTextNotices: false, forUI: false }, "NL": { text: "Nederlands", value: "NL", forTextNotices: true, forUI: false },
        "RO": { text: "Românesc", value: "RO", forTextNotices: false, forUI: false }, "RU": { text: "Русский", value: "RU", forTextNotices: false, forUI: false },
        "SK": { text: "Slovensky", value: "SK", forTextNotices: false, forUI: false }, "SR": { text: "Srpski", value: "SR", forTextNotices: false, forUI: false }
    },
    ajaxTimeout: 50, // в секунди
    uiTemplate: "windowsphone/light",
    isAndroid: false,
    isIOS: false,
    isWindows: false,
    isInitialized: false,
    factoryDefaultLanguage: "EN"
}

nts.restoreFactorySettings = function () {
    nts.config = {
        //production url
        serverUrl: "http://91.238.255.130:8083",
        version: nts.version,
        // serverUrl: "http://151.252.199.45:8080/NtS_Public",
        language: nts.languages[nts.factoryDefaultLanguage]
    }
}

nts.CheckVersion = function () {
    if (nts.config.version == undefined || nts.config.version != nts.version) {
        nts.config.version = nts.version;
        nts.restoreFactorySettings();
        nts.fileManager.writeConfigFile();
    }
}

nts.detectOS = function () {
    try {
        switch (device.platform) {
            //    case "Android": nts.uiTemplate = "android/blue"; nts.isAndroid = true; break;
            case "Android": nts.uiTemplate = "android/blue1.3.2"; nts.isAndroid = true; break;
                //    case "Android": nts.uiTemplate = "android/hololight"; nts.isAndroid = true; break;
            case "iOS": nts.uiTemplate = "ios"; nts.isIOS = true; break;
            default: nts.uiTemplate = "windowsphone/light"; nts.isWindows = true; break;
        }
    } catch (ex) { nts.uiTemplate = "windowsphone/light"; nts.isWindows = true; }
}

nts.onPageBeforeCreate = function (event, ui) {
    var page_id = $(event.target).attr("id");
    if (!page_id.match(/(settings|messageDialog)/)) {
        var settings_btn = $("#settingsButton");
        if (settings_btn) $(event.target).find("[data-role='header']").append(settings_btn.clone().show());
    }
    if (nts.isIOS) {
        var back_btn = $("#backButton");
        if (back_btn) $(event.target).find("[data-role='header']").append(back_btn.clone().show());
    }
    nts.locale.localize(page_id);
}

$(document).on("pagebeforecreate", "", nts.onPageBeforeCreate);

nts.loadAllPages = function () {
    $.mobile.loadPage("advancedSearch.html", { showLoadMsg: false });
    $.mobile.loadPage("quickSearch.html", { showLoadMsg: false });
    //$.mobile.loadPage("logIn.html", { showLoadMsg: false });
    $.mobile.loadPage("settings.html", { showLoadMsg: false });
    $.mobile.loadPage("nestedList.html", { showLoadMsg: false });
    $.mobile.loadPage("noticeDetails.html", { showLoadMsg: false });
    $.mobile.loadPage("oldList.html", { showLoadMsg: false });
    //$.mobile.loadPage("userDetails.html", { showLoadMsg: false });
    //$.mobile.loadPage("userSubscriptions.html", { showLoadMsg: false });
    $.mobile.loadPage("waterLevels.html", { showLoadMsg: false });
    $.mobile.loadPage("chartView.html", { showLoadMsg: false });
    $.mobile.loadPage("messageDialog.html", { showLoadMsg: false });    // --> ако не се зареди последна, се полъчава някакъв бъг с overlay 

}

nts.initUI = function () {
    try {
        nts.ui.common.setDialogsTransparency();
        nts.ui.main.showAllUI();
        nts.loadAllPages();
        nts.isInitialized = true;
    } catch (err) { }
}

nts.init = function () {

    $.mobile.showPageLoadingMsg();

    nts.fileManager.initFileSystem()
        .then(nts.fileManager.readConfigFile, nts.fileManager.handleFileError)
        .then(nts.CheckVersion, nts.restoreFactorySettings)
        .then(nts.locale.loadResources)
        .then(nts.locale.localizeMainPage, nts.locale.handleResourcesError)
        .then(nts.initUI)
        .then($.mobile.hidePageLoadingMsg);
}
//*****END---------------------- Инициализация

//---------------------- nts.fileManager
nts.fileManager = new function () {
    var fm = this;
    fm.fileSystem = undefined;

    fm.initFileSystem = function () {
        return new Promise(function (resolve, reject) {
            if (nts.fileManager.fileSystem) resolve();
            else {
                if (nts.emulatorMode) {

                    //       window.webkitStorageInfo.requestQuota(PERSISTENT, 1024 * 1024, function (grantedBytes) {
                    navigator.webkitPersistentStorage.requestQuota(1024 * 1024, function (grantedBytes) {
                        window.webkitRequestFileSystem(PERSISTENT, grantedBytes, function (fileSystem) {
                            nts.fileManager.fileSystem = fileSystem;
                            resolve();
                        }, reject);
                    }, reject);
                } else {
                    if (!nts.isWindows) {
                        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function (fileSystem) {
                            nts.fileManager.fileSystem = fileSystem;
                            resolve();

                        }, reject);
                    } else {
                        console.log("windowsOS");
                        resolve();
                    };

                };
            };
        });
    }

    //**** Прочита съдържанието на текстов файл. [Promise] resolve(string Съдържанието на файла), reject(FileError)
    fm.readTextFile = function (fileName) {
        //  console.log("into readTextFile");
        var result;
        return new Promise(function (resolve, reject) {
            if (!fm.fileSystem && !nts.isWindows) {
                reject();
            } else {
                if (!nts.isWindows) {
                    fm.fileSystem.root.getFile(fileName, null, function (fileEntry) {

                        fileEntry.file(function (file) {
                            var reader = new FileReader();
                            reader.onload = function (evt) {
                                resolve(evt.target.result);
                            };
                            reader.onerror = reject;

                            reader.readAsText(file);
                        }, reject);
                    }, reject);
                } else {
                    if (window.localStorage.configFile) {
                        resolve(window.localStorage.configFile);
                    } else { reject(); }
                }
            }

        });
    }
    //**** Прочита JSON от текстов файл. [Promise] resolve(Резултатът от JSON кода), reject(FileError, JSON.parse error)
    fm.readJSONFile = function (fileName) {
        // console.log("into readJSONFile");
        return fm.readTextFile(fileName).then(JSON.parse);
    }

    //**** Записва текст във файл. [Promise] resolve(), reject(FileError)
    fm.writeTextFile = function (fileName, contents) {
        return new Promise(function (resolve, reject) {
            if (fm.fileSystem) {
                fm.fileSystem.root.getFile(fileName, { create: true, exclusive: false }, function (fileEntry) {
                    fileEntry.createWriter(function (writer) {
                        writer.truncate(0);
                        writer.abort();
                        writer.onwrite = function (evt) {
                            resolve();
                        };
                        writer.onerror = reject;
                        if (nts.emulatorMode) {
                            var blob = new Blob([contents], { type: 'text/plain' });
                            writer.write(blob);
                        } else writer.write(contents);
                    }, reject);
                }, reject);
            } else {
                if (!nts.isWindows) {
                    reject();
                } else {
                    window.localStorage.configFile = contents;
                    resolve();
                }
            }

        });
    }
    //**** Записва JSON в текстов файл. [Promise] resolve(), reject(FileError)
    fm.writeJSONFile = function (fileName, dataObject) {
        return fm.writeTextFile(fileName, JSON.stringify(dataObject));
    }

    //**** Прочита конфигурационния файл. [Promise] resolve(), reject(FileError, JSON.parse error)
    fm.readConfigFile = function (fileSystem) {
        return fm.readJSONFile(nts.configFileName).then(
            function (dataObject) {
                jQuery.extend(nts.config, dataObject)
            }
        );
    }
    //**** Записва конфигурационния файл. [Promise] resolve(), reject(FileError)
    fm.writeConfigFile = function () {
        return fm.writeJSONFile(nts.configFileName, nts.config);
    }

    fm.downloadFile = function (uri, fileName) {
        return new Promise(function (resolve, reject) {
            try {
                if (!fileName) fileName = nts.fileManager.fileSystem.root.toURL() + "TMP.TMP";

                var fileTransfer = new FileTransfer();
                fileTransfer.download(uri, fileName, resolve, reject);
                setInterval(function () { fileTransfer.abort(reject, reject) }, nts.ajaxTimeout * 1000);
            } catch (err) { reject(err) }
        });
    }

    fm.handleFileError = function (e) {
        var msg = '';
        console.log('error in file manager: ' + e.name);

        if (!nts.isWindows) {
            try {
                switch (e.name) {
                    case "QuotaExceededError":
                        msg = 'QUOTA_EXCEEDED_ERR';
                        break;
                    case "NotFoundError":
                        msg = 'NOT_FOUND_ERR';
                        break;
                    case "SecurityError":
                        msg = 'SECURITY_ERR';
                        break;
                    case "InvalidModificationError":
                        msg = 'INVALID_MODIFICATION_ERR';
                        break;
                    case "InvalidStateError":
                        msg = 'INVALID_STATE_ERR';
                        break;
                    default:
                        msg = 'Unknown Error';
                        break;
                }
            }
            catch (ex) {
                console.log('-----Exception Error: ' + ex.message);
            }
        } else {
            console.log('-----Error: file_not_found on windows phone 8');
        }
        console.log('-----Error: ' + msg);
    }

    fm.readXMLfile = function (fileName) {
        return new Promise(function (resolve, reject) {
            var ajaxOptions = { url: fileName, type: "GET" };
            nts.communicator.ajaxCall(ajaxOptions)
                .then(function (data) {
                    if (data) {
                        var xml;
                        if (data.documentElement) xml = $(data.documentElement);
                        else xml = $(data);
                        if (xml)
                            resolve(xml);
                        else reject();
                    }
                    else reject();
                }, reject);
        });

    }
}
//***END---------------------- nts.fileManager

//---------------------- nts.communicator
//---------------------- Връзка със сървъра
nts.communicator = new function () {
    var cm = this;

    cm.ajaxCall = function (ajaxOptions) {
        var aj = {};
        if (ajaxOptions) aj = ajaxOptions;
        if (aj.type == undefined) aj.type = "POST";
        if (aj.timeout == undefined) aj.timeout = nts.ajaxTimeout * 1000;

        return new Promise(function (resolve, reject) {
            aj.success = resolve;
            aj.error = reject;
            $.ajax(aj);
        });
    }

    cm.onFailedAjax = function (error) {

        var resourceCode;
        if (error) {
            switch (error.statusText) {
                case "NoContent": {
                    return nts.communicator.showDialog("NoSearchResult", "NO_SEARCH_RESULT");
                } break;
                case "timeout":
                case "error":
                    resourceCode = "NO_CONNECTION_TO_SERVER";
                    break;
                case "Not Found":
                    resourceCode = "NO_CONNECTION_TO_SERVER";
                    break;
                default:
                    console.log('-----Error: Грешка от сървъра:', error.responseText);
                    try {
                        resourceCode = JSON.parse(error.responseText);
                    }
                    catch (e) {
                        resourceCode = "SOMETHING_WRONG";
                    }
            }
        }

        return nts.communicator.showDialog("error", resourceCode);
    }

    cm.onError = function (errorCode) {
        console.log('-----Error: Грешка от сървъра:', errorCode);
        return nts.communicator.showDialog("error", errorCode);
    }

    cm.onMessage = function (data) {
        return nts.communicator.showDialog("success", data);
    }

    cm.showDialog = function (type, resourceCode) {
        return new Promise(function (resolve) {
            var titleResourceCode;
            switch (type) {
                case "NoSearchResult": {
                    titleResourceCode = "NO_SEARCH_RESULT";
                } break;
                case "error":
                    titleResourceCode = "lblError";
                    break;
                case "success":
                default:
                    titleResourceCode = "lblSuccess";
                    break;
            }

            var messageDialogTitleElement = $("#messageDialogTitle");
            $(messageDialogTitleElement).attr("glb_id", titleResourceCode);

            if (!nts.locale.getLocalizedResource(resourceCode)) {
                resourceCode = "SOMETHING_WRONG";
            }

            var messageDialogMessageElement = $("#messageDialogMessage");
            $(messageDialogMessageElement).attr("glb_id", resourceCode);

            nts.locale.localize("messageDialog");

            $(document).on("pagehide", "#messageDialog", resolve);
            $.mobile.changePage("messageDialog.html", { transition: "pop", role: "dialog" });
        });
    }

    cm.logError = function (error) {
        if (error.stack)
            console.log('-----Error: ', error.stack);
        else
            console.log('-----Error: ', error);
    }
}
//***END---------------------- nts.communicator


//---------------------- nts.ui.common
//---------------------- UI helpers
nts.ui.common = {
    modifySelect: function (selectObject, value) {
        selectObject.val(value).attr('selected', true).siblings('option').removeAttr('selected');
        selectObject.selectmenu("refresh", true);
    },
    setDialogsTransparency: function () {
        $('div[data-role="dialog"]').live('pagebeforeshow', function (e, ui) {
            ui.prevPage.addClass("ui-dialog-background ");
        });
        $('div[data-role="dialog"]').live('pagehide', function (e, ui) {
            $(".ui-dialog-background ").removeClass("ui-dialog-background ");
        });
    }
}
//***END---------------------- nts.ui.common




