﻿if (!nts.ui.quickSearch) {
    nts.ui.quickSearch = {
        search: function () {
            $.mobile.showPageLoadingMsg();

            var quickSearchURL = nts.config.serverUrl + "/Mobile/FastSearch";

            var quickSearchYear = parseInt($("#quickSearchYear").val(), 10);
            if (isNaN(quickSearchYear)) quickSearchYear = 0;

            var quickSearchNumber = parseInt($("#quickSearchNumber").val(), 10);
            if (isNaN(quickSearchNumber)) quickSearchNumber = 0;

            var systemLocale = nts.config.language.value;
           
            var ajaxOptions = {
                url: quickSearchURL,
                type: "GET",
                data: { year: quickSearchYear, number: quickSearchNumber, langCode: systemLocale }
            };

            nts.communicator.ajaxCall(ajaxOptions)
                .then(nts.ui.quickSearch.quickSearchResult, nts.communicator.onFailedAjax)
                .then($.mobile.hidePageLoadingMsg);
        },
        quickSearchResult: function (data) {
            if (data && data.length > 0) {
                var searchResult = data[0];
                nts.ui.listSettings.list.currentItem = [];
                nts.ui.listSettings.list.currentItem.push(searchResult);
                nts.ui.listSettings.list.oldList = [];
                $.each(searchResult.OldNotices, function (j, childData) {
                    nts.ui.listSettings.list.oldList.push(childData);
                });
                $.mobile.changePage("oldList.html");

                // For details
                nts.ui.noticeDetails.countryCode = "BG";
                //
            } else {
                nts.communicator.showDialog("NoSearchResult", "NO_SEARCH_RESULT");
            }
        }
    }
}