﻿if (!nts.ui.userDetails) {
    nts.ui.userDetails = {
        initPage: function () {
            if (nts.user.isNewUser()) {
                $("#userDetailsTitle").css('display', 'inline-block');
                $("#userDetailsUsername").css('display', 'none');
                $("#userDetailsLogOutButton").css('display', 'none');
                $("#userDetailsSave").css('display', 'none');
                $("#userDetailsGoNext").css('display', 'inline-block');

                $("#userDetailsNameText").css('display', 'none');
                $("#userDetailsEmailText").css('display', 'none');
                $("#userDetailsNameInput").css('display', 'inline-block').blur();
                $("#userDetailsEmailInput").css('display', 'inline-block').blur();
                $("#userDetailsPassword").text('').val('').blur();
                $("#userDetailsPasswordRepeat").text('').val('').blur();//unfocus - за да се задейства валидацията и да се скрие css+label за грешки
            }
            else {
                $("#userDetailsTitle").css('display', 'none');
                $("#userDetailsUsername").css('display', 'inline-block').text(nts.user.loggedInUser.EMAIL);
                $("#userDetailsLogOutButton").css('display', 'inline-block');
                $("#userDetailsSave").css('display', 'inline-block');
                $("#userDetailsGoNext").css('display', 'none');

                $("#userDetailsNameInput").val('').blur().css('display', 'none');//unfocus - за да се задейства валидацията
                $("#userDetailsEmailInput").val('').blur().css('display', 'none');//unfocus - за да се задейства валидацията               
                $("#userDetailsNameText").css('display', 'inline-block').text(nts.user.loggedInUser.NAME);
                $("#userDetailsEmailText").css('display', 'inline-block').text(nts.user.loggedInUser.EMAIL);
                $("#userDetailsPassword").text('').val('').blur();//unfocus - за да се задейства валидацията
                $("#userDetailsPasswordRepeat").text('').val('').blur();//unfocus - за да се задейства валидацията
            }
        },
        initValidation: function () {
            if ($("#userDetails form").length > 0) {
                try {
                    $("#userDetails form").validate({
                        rules: {
                            userDetailsName: {
                                required: {
                                    depends: function(element) {
                                        return nts.user.isNewUser();
                                    }
                                }
                            },
                            userDetailsEmail: {
                                required: {
                                    depends: function (element) {
                                        return nts.user.isNewUser();
                                    }
                                },
                                email: {
                                    depends: function (element) {
                                        return nts.user.isNewUser();
                                    }
                                }
                            },
                            userDetailsPassword: {
                                required:  {
                                    depends: function (element) {
                                        return nts.user.isNewUser();
                                    }
                                }
                            },
                            userDetailsPasswordRepeat: {
                                equalTo: "#userDetailsPassword"                            
                            }
                        },
                        messages: {
                            userDetailsName: {
                                required: function (element) {
                                    return jQuery.validator.format(nts.locale.getLocalizedResource("lblRequiredField"), nts.locale.getLocalizedResource("lblUserName"));
                                }
                            },
                            userDetailsEmail: {
                                required: function (element) {
                                    return jQuery.validator.format(nts.locale.getLocalizedResource("lblRequiredField"), nts.locale.getLocalizedResource("lblUserEmail"));
                                },
                                email: function (element) {
                                    return nts.locale.getLocalizedResource("lblInvalidEmail");
                                }
                            },
                            userDetailsPassword: {
                                required: function (element) {
                                    return jQuery.validator.format(nts.locale.getLocalizedResource("lblRequiredField"), nts.locale.getLocalizedResource("lblUserPassword"));
                                }
                            },
                            userDetailsPasswordRepeat: {
                                equalTo: function (element) {
                                    return nts.locale.getLocalizedResource("lblPasswordsDontMatch");
                                }
                            },
                        },
                        focusInvalid: false
                    
                    });
                }
                catch (e) {
                    console.log(e);
                    console.log('-----Error: Грешка при инициализацията на jquery validate. Вероятно липсват ресурсни кодове.');
                }
            }
        },
        save: function () {
            var userDetailsForm = $("#userDetails form");
            if (userDetailsForm.valid()) {
                if (!nts.user.isNewUser() && $("#userDetailsPassword").val().length > 0) {
                    var password = $("#userDetailsPassword").val();
                    var hashedPassword = CryptoJS.MD5(password).toString();

                    nts.user.loggedInUser.NEWPASSWORD = hashedPassword;
                    nts.user.save(); //TODO ще се промени при допълнителни полета на потребителя
                }
                else $.mobile.changePage("userSubscriptions.html");
            }
        },
        goNext: function () {
            
            var userDetailsForm = $("#userDetails form");
            if (userDetailsForm.valid() && nts.user.isNewUser()) {

                $.mobile.showPageLoadingMsg();

                if (!nts.user.loggedInUser) nts.user.loggedInUser = {};
                nts.user.loggedInUser.NAME = $("#userDetailsNameInput").val();
                nts.user.loggedInUser.EMAIL = $("#userDetailsEmailInput").val();
                nts.user.loggedInUser.NEWPASSWORD = $("#userDetailsPassword").val();  

                var checkEmailURL = nts.config.serverUrl + "/Mobile/IsEmailFreeAndValid";

                var ajaxOptions = {
                    url: checkEmailURL,
                    type: "GET",
                    data: { email: nts.user.loggedInUser.EMAIL },
                    dataType: 'json'
                };

                nts.communicator.ajaxCall(ajaxOptions)
                    .then(nts.ui.userDetails.emailCheckOK, nts.communicator.onFailedAjax)
                    .then($.mobile.hidePageLoadingMsg);
            }
        },
        emailCheckOK: function (data) {
            if (data == true) {
                $.mobile.changePage("userSubscriptions.html");
            }
        }
    }
}