﻿if (!nts.ui.userSubscriptions) {
    nts.ui.userSubscriptions = {
        loadData: function () {
            try {
                if (nts.user.loggedInUser) {
                    if (nts.user.loggedInUser.ACTIVE == 1) {
                        $("#userSubscriptionsTitle").text(nts.user.loggedInUser.EMAIL);
                        $("#userSubscriptionsTitle").wrapInner("<a href='userDetails.html'></a>");
                        $("#logOutButton").css('display', 'inline-block');
                    }
                    else {
                        $("#userSubscriptionsTitle").text(nts.locale.getLocalizedResource("lblRegister"));
                        $("#logOutButton").css('display', 'none');
                    }

                    //toggle Language select controls
                    $('input[name^="TextFor"], input[name^="CodeFor"]').bind("change", function (event, ui) {
                        nts.ui.userSubscriptions.toggleLanguageControls(event.target);
                    });

                    //fill in all user data
                    $('#userSubscriptionsForm input[type=checkbox]').each(function () {
                        $(this).prop('checked', !!+nts.user.loggedInUser[this.name]).checkboxradio("refresh").each(function () { nts.ui.userSubscriptions.toggleLanguageControls(this); });
                    });

                    $('#userSubscriptionsForm select').each(function () {
                        if (nts.user.loggedInUser[this.name] &&
                            $(this).find('option[value="' + nts.user.loggedInUser[this.name] + '"]').length > 0) {
                            $(this).val(nts.user.loggedInUser[this.name]).attr('selected', true).selectmenu("refresh", true);
                        }
                    });

                    $('#userSubscriptionsForm div.ui-icon-check').each(function () {
                        if (nts.user.loggedInUser[this.id] === 1)
                            $(this).css('display', 'inline-block');
                        else
                            $(this).css('display', 'none');
                    });

                    //close collapsibles
                    $('#userSubscriptionsForm [data-role]="collapsible"').trigger('collapse');


                }
            }
            catch (e) {
                nts.communicator.logError(e);
            }
        },
        toggleLanguageControls: function (checkboxHtmlInput) {
            var checkbox = $(checkboxHtmlInput);
            var msgType = checkbox.data("messageType");
            var msgFormat = checkbox.data("messageFormat");
            var langSelectId = 'LangFor' + msgFormat + msgType;
            if (checkbox.prop("checked")) {
                //       alert($(e.target).prop("checked")); 
                //        $('#LangForTextFTMContainer').show(); 
                $('#' + langSelectId).selectmenu("enable");//.selectmenu("refresh", true);
            } else {
                //       alert($(e.target).prop("checked"));
                //    $('#LangForTextFTMContainer').hide();
                $('#' + langSelectId).selectmenu("disable");//.selectmenu("refresh", true);
            }
        },
        save: function () {
            if (nts.user.loggedInUser) {
                //read all user data
                $('#userSubscriptionsForm input[type=checkbox]').each(function () {
                    nts.user.loggedInUser[this.name] = $(this).prop('checked') === true ? 1 : 0;
                });
                $('#userSubscriptionsForm select[name*="Text"]').each(function () {
                    format = "TextFor" + $(this).data("messageType");
                    isFormatChecked = nts.user.loggedInUser[format];
                    nts.user.loggedInUser[this.name] = (isFormatChecked == 0) ? null : $(this).val();
                });
                $('#userSubscriptionsForm select[name*="Code"]').each(function () {
                    format = "CodeFor" + $(this).data("messageType");
                    isFormatChecked = nts.user.loggedInUser[format];
                    nts.user.loggedInUser[this.name] = (isFormatChecked == 0) ? null : $(this).val();
                });
                
                nts.user.loggedInUser.FTM = (nts.user.loggedInUser.TextForFTM + nts.user.loggedInUser.CodeForFTM + nts.user.loggedInUser.XMLForFTM) > 0 ? 1 : 0;
                nts.user.loggedInUser.WRM = (nts.user.loggedInUser.TextForWRM + nts.user.loggedInUser.CodeForWRM + nts.user.loggedInUser.XMLForWRM) > 0 ? 1 : 0;
                nts.user.loggedInUser.ICEM = (nts.user.loggedInUser.TextForICEM + nts.user.loggedInUser.CodeForICEM + nts.user.loggedInUser.XMLForICEM) > 0 ? 1 : 0;
                nts.user.loggedInUser.WERM = (nts.user.loggedInUser.TextForWERM + nts.user.loggedInUser.CodeForWERM + nts.user.loggedInUser.XMLForWERM) > 0 ? 1 : 0;

                if (nts.user.loggedInUser.FTM + nts.user.loggedInUser.WRM + nts.user.loggedInUser.ICEM + nts.user.loggedInUser.WERM > 0) {
                    nts.user.save();
                }
                else
                    nts.communicator.onError("SUBS_NOT_SELECTED");
            }
        }
    }
}