﻿if (!nts.ui.waterLevels) {
    nts.ui.waterLevels = {
        latestWaterLevels: [{ "ISRS": null, "ObjectName": null, "MeasureDate": null, "MeasureValue": null, "Difference": null, "KM": null }],
        InitWaterLevels: function () {
            if (window.orientation == 0) {
                nts.ui.waterLevels.WindowWidth = $(window).width();
                nts.ui.waterLevels.WindowHeight = $(window).height();
            } else {
                nts.ui.waterLevels.WindowWidth = $(window).height();
                nts.ui.waterLevels.WindowHeight = $(window).width();
            }
        },
        WindowWidth: 0,
        ObjectName: "",
        WindowHeight: 0,
        chartViewData: [],
        minScaleValue: 0,
        maxScaleValue: 0,
        getChartData: function (event) {
            var isrs = $(event.currentTarget).attr("id").replace("ntsWaterLevelsItem", "");
            $.mobile.showPageLoadingMsg();
            var ajaxOptions = {
                url: nts.config.serverUrl + "/Mobile/GetChartData",
                data: { "isrs": isrs, "culture": nts.config.language.value, "stringDate": $(event.currentTarget).find("div[data-value-date='this']").text() },
                type: "POST"
            };

            for (var i = 0; i < nts.ui.waterLevels.latestWaterLevels.length; i++) {
                if (nts.ui.waterLevels.latestWaterLevels[i].ISRS == isrs) {
                    nts.ui.waterLevels.ObjectName = nts.ui.waterLevels.latestWaterLevels[i].ObjectName;
                    break;
                }
            }

            nts.communicator.ajaxCall(ajaxOptions)
            .then(nts.ui.waterLevels.successChartData, nts.communicator.onFailedAjax)
            .then($.mobile.hidePageLoadingMsg);

        },
        ChartScreenRotation: function (event) {

            nts.ui.waterLevels.dataChart.destroy();
            $("#waterLevelsChart").removeAttr("height");
            $("#waterLevelsChart").removeAttr("width");
            nts.ui.waterLevels.buildChart($("#chartViewHeader").height());
        },
        successChartData: function (data) {

            if (data.result != "" && data.result != "[]" && data.result != undefined) {
                nts.ui.waterLevels.chartViewData = data.result;
                nts.ui.waterLevels.minScaleValue = data.minValue;
                nts.ui.waterLevels.maxScaleValue = data.maxValue;
                $("#chartView").find("h1").text(nts.locale.getLocalizedResource("lblLineChart") + " " + nts.ui.waterLevels.ObjectName);

                nts.ui.waterLevels.buildChart($("#waterLevelsPage").find("div[data-role='header']").height());
                $.mobile.changePage("chartView.html");
            } else {
                $("#messageDialogTitle").text(nts.locale.getLocalizedResource("NO_SEARCH_RESULT"));
                $("#messageDialogMessageContainer").text(nts.locale.getLocalizedResource("NO_SEARCH_RESULT"));
                $.mobile.changePage("messageDialog.html");
            }
        },
        buildChart: function (HeaderHeight) {

            if (nts.ui.waterLevels.dataChart.destroy != undefined) {
                nts.ui.waterLevels.dataChart.destroy();
                $("#waterLevelsChart").removeAttr("height");
                $("#waterLevelsChart").removeAttr("width");
            }
            var height = 0;
            var width = 0;

            if (window.orientation == 0) {
                width = nts.ui.waterLevels.WindowWidth;
                height = nts.ui.waterLevels.WindowHeight - (HeaderHeight * 2);
            } else {
                width = nts.ui.waterLevels.WindowHeight;
                height = (nts.ui.waterLevels.WindowWidth - (HeaderHeight * 2));
            }

            var labels = [];
            var values = [];
     
            var labelsCount = parseInt(nts.ui.waterLevels.chartViewData.length / 7);
            for (var i = 0; i < nts.ui.waterLevels.chartViewData.length; i++) {
                labels[i] = nts.ui.waterLevels.chartViewData[i].MeasureDate;
                values[i] = nts.ui.waterLevels.chartViewData[i].MeasureValue;
            }

            var data = {
                labels: labels,
                datasets: [{
                    label: "Water Levels",
                    fillColor: "#1F497D",
                    strokeColor: "rgb(255,0,0)",
                    data: values
                }]
            };

         

            var options = {
                scaleOverride: true,
                // ** Required if scaleOverride is true **
                // Number - The number of steps in a hard coded scale
                // Boolean - Whether to animate the chart
                animation: true,
                // Number - Number of animation steps
                animationSteps: 30,
                // String - Animation easing effect
                animationEasing: "linear",
                // Boolean - If we should show the scale at all
                showScale: true,
                // Boolean - If we want to override with a hard coded scale
                scaleOverride: true,
                // String - Colour of the scale line
                scaleLineColor: "rgba(244,0,0,.1)",
                // Number - Pixel width of the scale line
                scaleLineWidth: 1,
                // Boolean - Whether to show labels on the scale
                scaleShowLabels: true,
                // Interpolated JS string - can access value
                scaleLabel: "<%=value%>",
                // Boolean - Whether the scale should stick to integers, not floats even if drawing space is there
                scaleIntegersOnly: true,
                // Boolean - Whether the scale should start at zero, or an order of magnitude down from the lowest value
                scaleBeginAtZero: false,
                // String - Scale label font declaration for the scale label
                scaleFontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
                // Number - Scale label font size in pixels
                scaleFontSize: 12,
                // String - Scale label font weight style
                scaleFontStyle: "normal",
                // String - Scale label font colour
                scaleFontColor: "#000",
                scaleSteps: parseInt((nts.ui.waterLevels.maxScaleValue - (parseInt(nts.ui.waterLevels.minScaleValue / 100) * 100)) / 50) + 1,
                // Number - The value jump in the hard coded scale
                scaleStepWidth: 50,
                // Number - The scale starting value
                scaleStartValue: parseInt(nts.ui.waterLevels.minScaleValue / 100) * 100,
                //Boolean - Whether grid lines are shown across the chart
                scaleShowGridLines: true,
                //String - Colour of the grid lines
                scaleGridLineColor: "rgba(0,0,0,.08)",
                //Number - Width of the grid lines
                scaleGridLineWidth: 1,
                //Boolean - If there is a stroke on each bar
                barShowStroke: false,
                //Number - Pixel width of the bar stroke
                barStrokeWidth: 2,
                //Number - Spacing between each of the X value sets
                barValueSpacing: 0,
                //Number - Spacing between data sets within X values
                barDatasetSpacing: 0,
                //String - A legend template
                legendTemplate: "<ul class=\"<%=name.toLowerCase()%>-legend\"><% for (var i=0; i<datasets.length; i++){%><li><span style=\"background-color:<%=datasets[i].lineColor%>\"></span><%if(datasets[i].label){%><%=datasets[i].label%><%}%></li><%}%></ul>"
            };

            var ctx = $("#waterLevelsChart").get(0).getContext("2d");
            // This will get the first returned node in the jQuery collection.

            //if (window.devicePixelRatio) {
            //    ctx.canvas.style.width = width + "px";
            //    ctx.canvas.style.height = height + "px";
            //    ctx.canvas.height = height * window.devicePixelRatio;
            //    ctx.canvas.width = width * window.devicePixelRatio;
            //    //ctx.scale(window.devicePixelRatio, window.devicePixelRatio);
            //}

            ctx.canvas.width = width;
            ctx.canvas.height = height;

            nts.ui.waterLevels.dataChart = new Chart(ctx).Bar(data, options);

            //nts.ui.waterLevels.dataChart = new Chart(ctx).Line(data, options);
            //  $("#waterLevelsChart").css("width", width + "px");
            //  $("#waterLevelsChart").css("height", height + "px");
        },
        dataChart: {},
        getLatestWaterLevels: function () {

            $.mobile.showPageLoadingMsg();
            var ajaxOptions = {
                url: nts.config.serverUrl + "/Mobile/GetLatestWaterLevels?culture=" + nts.config.language.value,
                type: "GET"
            };

            nts.communicator.ajaxCall(ajaxOptions)
            .then(nts.ui.waterLevels.successGetLatestWaterLevels, nts.communicator.onFailedAjax)
            .then($.mobile.hidePageLoadingMsg);
        },
        successGetLatestWaterLevels: function (data) {

            $.mobile.hidePageLoadingMsg();
            if (data != "") {
                nts.ui.waterLevels.latestWaterLevels = data;
                var itemTemplateWaterLevels = $('#itemTemplateWaterLevels').html();
                $("#listViewWaterLatestWaterLevels").igList({
                    dataSource: nts.ui.waterLevels.latestWaterLevels,
                    itemTemplate: itemTemplateWaterLevels,
                    itemTheme: "b"
                });
                $("#listViewWaterLatestWaterLevels").find('[id^="ntsWaterLevelsItem"]').off("click").on("click", nts.ui.waterLevels.getChartData);
                $.mobile.changePage("waterLevels.html");
            } else {
                $("#messageDialogTitle").text(nts.locale.getLocalizedResource("NO_SEARCH_RESULT"));
                $("#messageDialogMessageContainer").text(nts.locale.getLocalizedResource("NO_SEARCH_RESULT"));
                $.mobile.changePage("messageDialog.html");
            }
            return;
        }
    }
    nts.ui.waterLevels.InitWaterLevels();
}